let testValue = 60;
const readTemperature = () => {
    // test value 
    if (testValue < 75)
        return Q(testValue++);
    else 
        return Q(testValue--);
    
    // read temperature from device
    // const u2a = document.querySelector('ti-model-register').getCodec();
    // u2a.sendCommandPacket(0x19, [1,1,1,1,2]);
    // return u2a.readResponse(u2a.sendCommandPacket(0x1A, [12, 0])).then(packet => {
	   //var payload = packet.slice(8);
	
	   //var Vref = 3.3;
	   //var hibyte = payload[0];
	   //var lobyte = payload[1];
	   //var word = (hibyte << 8) | (lobyte & 0xFF);
	   //var voltage = (word * Vref) / (Math.pow(2, 12));
	   
	   //var temperatureCelsius = -1481.96 + Math.sqrt(2.1962 * Math.pow(10, 6) + ((1.8639 - voltage) / (3.88 * Math.pow(10, -6))));
	   ////var temperatureFahrenheit = (temperatureCelsius * 1.8) + 32;
	   
	   ////console.log(payload, hibyte, lobyte, word);
	   
    //   console.log(temperatureCelsius);
    //   return temperatureCelsius;
    // });
};

/* add binding */
document.addEventListener('gc-databind-ready', function() {
    const tempBinding = gc.databind.registry.getBinding('prop.value');

    // gc.databind.registry.bind('widget.ti_widget_scalargraph.value_0', 'prop.value');
    gc.databind.registry.bind('widget.ti_widget_temperaturegraph.temperature', 'prop.value');
    gc.databind.registry.bind('widget.ti_widget_textbox_temp.value', 'prop.value');
    
});

/* setup widget event listener */
var initComplete = false;
var templateObj;
var init = function() {
    templateObj = document.querySelector('#template_obj');
	templateObj.addEventListener('dom-change', () => {
	    if (initComplete) return;
	    
	    templateObj.async(() => {
    	    initComplete = true;

            /* add mouse click event listener */
            const tempBinding = gc.databind.registry.getBinding('prop.value');
            templateObj.$.ti_widget_button_read.addEventListener('click', () => {
                readTemperature().then(temperature => {
                    tempBinding.setValue(temperature);
                    
                    /* scalar graph binding doesn't work (not sure why yet), set the value directly */
                    templateObj.$.ti_widget_scalargraph.value_0 = temperature;
                });
            });
        }, 1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded', init.bind(this))
}